/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt8.dat, Wed Jan 25 18:09:24 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001093 (4243)
 *     Revision         0x01
 *     Checksum         0x8C
 *     OEM ID           "AmdRef"
 *     OEM Table ID     "AmdTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("ssdt8.aml", "SSDT", 1, "AmdRef", "AmdTabl", 0x00001000)
{
    /*
     * iASL Warning: There were 9 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.GFX0.AINT, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (_SB_.PCI0.GFX0.IDAB, MethodObj)    // Warning: Unresolved method, guessing 0 arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // Warning: Unresolved method, guessing 2 arguments
    External (AMDA, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (DSEL, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (ESEL, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (SGOF, MethodObj)    // Warning: Unresolved method, guessing 0 arguments
    External (SGON, MethodObj)    // Warning: Unresolved method, guessing 0 arguments
    External (SSEL, MethodObj)    // Warning: Unresolved method, guessing 1 arguments

    External (_SB_.PCI0.GFX0, DeviceObj)
    External (_SB_.PCI0.LPCB.H_EC.LSTE, UnknownObj)
    External (_SB_.PCI0.PEG0, UnknownObj)
    External (_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP.DD02, UnknownObj)
    External (DSEN, UnknownObj)
    External (ECG3, IntObj)
    External (ECON, IntObj)
    External (MXD2, UnknownObj)
    External (MXD3, UnknownObj)
    External (MXD4, UnknownObj)
    External (MXD5, UnknownObj)
    External (MXD6, UnknownObj)
    External (MXD7, UnknownObj)
    External (NXD1, UnknownObj)
    External (NXD2, UnknownObj)
    External (NXD3, UnknownObj)
    External (NXD4, UnknownObj)
    External (NXD5, UnknownObj)
    External (NXD6, UnknownObj)
    External (NXD7, UnknownObj)
    External (NXD8, UnknownObj)
    External (PXFD, UnknownObj)
    External (SGFL, UnknownObj)
    External (SGMD, UnknownObj)

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            SGON ()
            Notify (\_SB.PCI0.PEG0, Zero) // Bus Check
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            SGOF ()
            Notify (\_SB.PCI0.PEG0, Zero) // Bus Check
        }

        Method (_STA, 0, Serialized)  // _STA: Status
        {
            Return (0x0F)
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        OperationRegion (APXM, SystemMemory, AMDA (0x00020400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                APXA,   32, 
                RVBS,   32, 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                DSWR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                EMDR,   8, 
                PXGS,   8, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                EXPM,   8, 
                TLSN,   16, 
                ELCL,   16, 
                RBF1,   262144, 
                RBF2,   262144, 
                RBF3,   262144, 
                RBF4,   262144
            })
        Method (ADPM, 2, Serialized)
        {
            Local1 = Zero
            Local0 = (Arg0 >> 0x10)
            If ((Arg1 == One))
            {
                Local1 |= (Local0 & One)
            }
            Else
            {
                Local1 |= ((Local0 & 0x02) >> One)
            }

            Local1 <<= One
            Local0 = (Arg0 >> 0x18)
            If ((Arg1 == One))
            {
                Local1 |= (Local0 & One)
            }
            Else
            {
                Local1 |= ((Local0 & 0x02) >> One)
            }

            Local1 <<= One
            Local0 = (Arg0 >> 0x08)
            If ((Arg1 == One))
            {
                Local1 |= (Local0 & One)
            }
            Else
            {
                Local1 |= ((Local0 & 0x02) >> One)
            }

            Return (Local1)
        }

        Method (ATPX, 2, Serialized)
        {
            If ((Arg0 == Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                F0SS = 0x08
                F0IV = One
                F0SF = 0xBF
                If ((SGMD == 0x02))
                {
                    F0SF = 0x33
                }

                Return (TMP1) /* \_SB_.PCI0.GFX0.ATPX.TMP1 */
            }

            If ((Arg0 == One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                F1SS = 0x0A
                F1VM = 0x7FFF
                If ((SGMD == 0x02))
                {
                    F1FG = 0x0280
                    If ((PXFD == One))
                    {
                        F1FG = 0x5E80
                    }
                }
                Else
                {
                    F1FG = 0x40
                }

                Return (TMP2) /* \_SB_.PCI0.GFX0.ATPX.TMP2 */
            }

            If ((Arg0 == 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If ((DGPR == Zero))
                {
                    \_SB.PCI0.PEG0.PEGP._OFF ()
                }

                If ((DGPR == One))
                {
                    \_SB.PCI0.PEG0.PEGP._ON ()
                }

                Return (Zero)
            }

            If ((Arg0 == 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                If ((SDMG == Zero))
                {
                    \_SB.PCI0.PEG0.PEGP.SGPO (DSEL (Zero), If ((SDMG == One))
                        {
                            \_SB.PCI0.PEG0.PEGP.SGPO (SSEL (One), Return (Zero))
                        })
                }
            }

            If ((Arg0 == 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                If ((SIMG == Zero))
                {
                    \_SB.PCI0.PEG0.PEGP.SGPO (ESEL (Zero), If ((SIMG == One))
                        {
                            \_SB.PCI0.PEG0.PEGP.SGPO (ESEL (One), Return (Zero))
                        })
                }
            }

            If ((Arg0 == 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                TGXA = TGFX /* \_SB_.PCI0.GFX0.ATPX.TGFX */
                GSTP = One
                Return (Zero)
            }

            If ((Arg0 == 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                AGXA = AGFX /* \_SB_.PCI0.GFX0.ATPX.AGFX */
                GSTP = Zero
                Return (Zero)
            }

            If ((Arg0 == 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    /* 0000 */  0x0E, 0x00, 0x46, 0x00, 0x07, 0x01, 0x00, 0x00,  /* ..F..... */
                    /* 0008 */  0x01, 0x07, 0x01, 0x01, 0x00, 0x01, 0x05, 0x00,  /* ........ */
                    /* 0010 */  0x00, 0x00, 0x04, 0x05, 0x00, 0x01, 0x10, 0x01,  /* ........ */
                    /* 0018 */  0x07, 0x03, 0x00, 0x00, 0x03, 0x07, 0x03, 0x01,  /* ........ */
                    /* 0020 */  0x10, 0x02, 0x07, 0x07, 0x00, 0x01, 0x03, 0x07,  /* ........ */
                    /* 0028 */  0x07, 0x01, 0x10, 0x02, 0x07, 0x09, 0x00, 0x02,  /* ........ */
                    /* 0030 */  0x03, 0x07, 0x09, 0x01, 0x20, 0x02, 0x07, 0x0A,  /* .... ... */
                    /* 0038 */  0x00, 0x03, 0x03, 0x07, 0x0A, 0x01, 0x30, 0x02,  /* ......0. */
                    /* 0040 */  0x07, 0x0B, 0x00, 0x04, 0x03, 0x07, 0x0B, 0x01,  /* ........ */
                    /* 0048 */  0x30, 0x02, 0x07, 0x0C, 0x00, 0x06, 0x03         /* 0...... */
                })
                CreateWordField (TMP3, Zero, ATNO)
                CreateWordField (TMP3, 0x02, ATSZ)
                TMP3 [0x0E] = ADPM (MXD2, One)
                TMP3 [0x13] = ADPM (MXD2, One)
                TMP3 [0x18] = ADPM (MXD3, One)
                TMP3 [0x1D] = ADPM (MXD3, 0x02)
                TMP3 [0x22] = ADPM (MXD4, One)
                TMP3 [0x27] = ADPM (MXD4, 0x02)
                TMP3 [0x2C] = ADPM (MXD5, One)
                TMP3 [0x31] = ADPM (MXD5, 0x02)
                TMP3 [0x36] = ADPM (MXD6, One)
                TMP3 [0x3B] = ADPM (MXD6, 0x02)
                TMP3 [0x40] = ADPM (MXD7, One)
                TMP3 [0x45] = ADPM (MXD7, 0x02)
                If ((SGFL & One))
                {
                    ATNO = (ATNO + One)
                    ATSZ = (ATSZ + 0x05)
                }

                Return (TMP3) /* \_SB_.PCI0.GFX0.ATPX.TMP3 */
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Local0 = Arg0
            Local1 = Arg1
            If ((Local1 > 0x1000))
            {
                Local1 = 0x1000
            }

            If ((Local0 > 0x00010000))
            {
                Return (Buffer (Local1)
                {
                     0x00                                             /* . */
                })
            }

            If ((Local0 > RVBS))
            {
                Return (Buffer (Local1)
                {
                     0x00                                             /* . */
                })
            }

            Local3 = (Local1 * 0x08)
            Name (ROM1, Buffer (0x8000)
            {
                 0x00                                             /* . */
            })
            Name (ROM2, Buffer (Local1)
            {
                 0x00                                             /* . */
            })
            If ((Local0 < 0x8000))
            {
                ROM1 = RBF1 /* \_SB_.PCI0.GFX0.RBF1 */
            }
            ElseIf ((Local0 < 0x00010000))
            {
                Local0 -= 0x8000
                ROM1 = RBF2 /* \_SB_.PCI0.GFX0.RBF2 */
            }
            ElseIf ((Local0 < 0x00018000))
            {
                Local0 -= 0x00010000
                ROM1 = RBF3 /* \_SB_.PCI0.GFX0.RBF3 */
            }
            ElseIf ((Local0 < 0x00020000))
            {
                Local0 -= 0x00018000
                ROM1 = RBF4 /* \_SB_.PCI0.GFX0.RBF4 */
            }

            Local2 = (Local0 * 0x08)
            CreateField (ROM1, Local2, Local3, TMPB)
            ROM2 = TMPB /* \_SB_.PCI0.GFX0.ATRM.TMPB */
            Return (ROM2) /* \_SB_.PCI0.GFX0.ATRM.ROM2 */
        }

        Method (INDL, 0, Serialized)
        {
            NXD1 = Zero
            NXD2 = Zero
            NXD3 = Zero
            NXD4 = Zero
            NXD5 = Zero
            NXD6 = Zero
            NXD7 = Zero
            NXD8 = Zero
        }

        Method (SNXD, 1, Serialized)
        {
            INDL ()
            Local0 = Arg0
            If ((Local0 & 0x02))
            {
                NXD1 = One
            }

            If ((Local0 & One))
            {
                NXD2 = One
            }

            If ((Local0 & 0x08))
            {
                NXD3 = One
            }

            If ((Local0 & 0x80))
            {
                NXD4 = One
            }

            If ((Local0 & 0x0200))
            {
                NXD5 = One
            }

            If ((Local0 & 0x0400))
            {
                NXD6 = One
            }

            If ((Local0 & 0x0800))
            {
                NXD7 = One
            }
        }

        Method (ATIF, 2, Serialized)
        {
            If ((Arg0 == Zero))
            {
                Name (TMP0, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP0, Zero, F0SS)
                CreateWordField (TMP0, 0x02, F0IV)
                CreateDWordField (TMP0, 0x04, F0SN)
                CreateDWordField (TMP0, 0x08, F0SF)
                F0SS = 0x0C
                F0IV = One
                F0SN = 0x01F1
                F0SF = 0x400F
                Return (TMP0) /* \_SB_.PCI0.GFX0.ATIF.TMP0 */
            }

            If ((Arg0 == One))
            {
                Name (TMP1, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP1, Zero, F1SS)
                CreateDWordField (TMP1, 0x02, F1VF)
                CreateDWordField (TMP1, 0x06, F1FG)
                F1SS = 0x0A
                F1VF = 0x03
                F1FG = One
                Return (TMP1) /* \_SB_.PCI0.GFX0.ATIF.TMP1 */
            }

            If ((Arg0 == 0x02))
            {
                CreateBitField (PSBR, Zero, PDSW)
                CreateBitField (PSBR, One, PEXM)
                CreateBitField (PSBR, 0x02, PTHR)
                CreateBitField (PSBR, 0x03, PFPS)
                CreateBitField (PSBR, 0x04, PSPS)
                CreateBitField (PSBR, 0x05, PDCC)
                CreateBitField (PSBR, 0x06, PXPS)
                CreateBitField (PSBR, 0x07, PBRT)
                CreateBitField (PSBR, 0x08, DCSC)
                CreateWordField (ATIB, Zero, SSZE)
                CreateDWordField (ATIB, 0x02, PSBI)
                CreateByteField (ATIB, 0x06, EXPM)
                CreateByteField (ATIB, 0x07, THRM)
                CreateByteField (ATIB, 0x08, THID)
                CreateByteField (ATIB, 0x09, FPWR)
                CreateByteField (ATIB, 0x0A, FPID)
                CreateByteField (ATIB, 0x0B, SPWR)
                CreateByteField (ATIB, 0x0C, BRTL)
                SSZE = 0x0D
                PSBI = PSBR /* \_SB_.PCI0.GFX0.PSBR */
                If (PDSW)
                {
                    PDSW = Zero
                }

                If (PEXM)
                {
                    EXPM = Zero
                    PEXM = Zero
                }

                If (PTHR)
                {
                    THRM = Zero
                    THID = Zero
                    PTHR = Zero
                }

                If (PFPS)
                {
                    PFPS = Zero
                }

                If (PSPS)
                {
                    PSPS = Zero
                }

                If (PXPS)
                {
                    PXPS = Zero
                }

                If (PBRT)
                {
                    PBRT = Zero
                }

                If (DCSC)
                {
                    DCSC = Zero
                }

                Return (ATIB) /* \_SB_.PCI0.GFX0.ATIB */
            }

            If ((Arg0 == 0x03))
            {
                Name (TMP3, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP3, Zero, F3SS)
                CreateWordField (TMP3, 0x02, F3SD)
                CreateWordField (Arg1, Zero, AI3S)
                CreateWordField (Arg1, 0x02, SLDS)
                CreateWordField (Arg1, 0x04, CODS)
                CACD = SLDS /* \_SB_.PCI0.GFX0.ATIF.SLDS */
                CCND = CODS /* \_SB_.PCI0.GFX0.ATIF.CODS */
                If (\ECON)
                {
                    If ((\_SB.PCI0.LPCB.H_EC.LSTE == One))
                    {
                        CCND |= One
                    }
                }

                F3SS = 0x04
                TLSN = CTOI (CACD)
                Local1 = CACD /* \_SB_.PCI0.GFX0.CACD */
                Local0 = NTLE /* \_SB_.PCI0.GFX0.NTLE */
                While (Local0)
                {
                    Local1 = NATL (TLSN)
                    If ((Local1 != Zero))
                    {
                        If (((Local1 & CCND) == Local1))
                        {
                            Local0 = One
                        }
                    }

                    Local0--
                    TLSN++
                    If ((TLSN > NTLE))
                    {
                        TLSN = One
                    }
                }

                SNXD (Local1)
                NACD = Local1
                F3SD = NACD /* \_SB_.PCI0.GFX0.NACD */
                Return (TMP3) /* \_SB_.PCI0.GFX0.ATIF.TMP3 */
            }

            If ((Arg0 == 0x04))
            {
                Name (TMP4, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMP4, Zero, F4SS)
                CreateByteField (TMP4, 0x02, F4LS)
                F4SS = 0x03
                F4LS = ECG3 /* External reference */
                Return (TMP4) /* \_SB_.PCI0.GFX0.ATIF.TMP4 */
            }

            If ((Arg0 == 0x0F))
            {
                Name (TMPF, Buffer (0x0100)
                {
                     0x00                                             /* . */
                })
                CreateWordField (TMPF, Zero, FFND)
                CreateWordField (TMPF, 0x02, FFDS)
                CreateDWordField (TMPF, 0x04, FFFG)
                CreateWordField (TMPF, 0x08, FFBS)
                CreateWordField (TMPF, 0x0A, FFDV)
                FFND = One
                FFDS = 0x08
                FFFG = 0x05
                FFBS = One
                FFDV = Zero
                Return (TMPF) /* \_SB_.PCI0.GFX0.ATIF.TMPF */
            }

            Return (Zero)
        }

        Name (ATIB, Buffer (0x0100) {})
        Name (PSBR, Buffer (0x04)
        {
             0x00                                             /* . */
        })
        Name (SSPS, Zero)
        Method (AFN0, 0, Serialized)
        {
            CreateBitField (PSBR, Zero, PDSW)
            PDSW = One
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }

        Method (AFN4, 1, Serialized)
        {
            Local0 = Arg0
            Local1 = SSPS /* \_SB_.PCI0.GFX0.SSPS */
            SSPS = Local0
            If ((Local0 == Local1)) {}
            Else
            {
                CreateBitField (PSBR, 0x04, PSPS)
                PSPS = One
                Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
            }
        }

        Method (AFN5, 0, Serialized)
        {
            CreateBitField (PSBR, 0x05, PDCC)
            PDCC = One
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }

        Method (AFN6, 0, Serialized)
        {
            CreateBitField (PSBR, 0x06, PXPS)
            PXPS = One
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }

        Method (AFN7, 1, Serialized)
        {
            CreateBitField (PSBR, 0x07, PBRT)
            PBRT = One
            CreateByteField (ATIB, 0x0C, BRTL)
            BRTL = Arg0
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }

        Method (AFN8, 0, Serialized)
        {
            CreateBitField (PSBR, 0x08, DCSC)
            DCSC = One
            Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
        }

        Method (CTOI, 1, NotSerialized)
        {
            If ((NTLE != Zero))
            {
                If ((TLE1 == Arg0))
                {
                    Return (One)
                }

                If ((TLE2 == Arg0))
                {
                    Return (0x02)
                }

                If ((TLE3 == Arg0))
                {
                    Return (0x03)
                }

                If ((TLE4 == Arg0))
                {
                    Return (0x04)
                }

                If ((TLE5 == Arg0))
                {
                    Return (0x05)
                }

                If ((TLE6 == Arg0))
                {
                    Return (0x06)
                }

                If ((TLE7 == Arg0))
                {
                    Return (0x07)
                }

                If ((TLE8 == Arg0))
                {
                    Return (0x08)
                }

                If ((TLE9 == Arg0))
                {
                    Return (0x09)
                }

                If ((TL10 == Arg0))
                {
                    Return (0x0A)
                }

                If ((TL11 == Arg0))
                {
                    Return (0x0B)
                }

                If ((TL12 == Arg0))
                {
                    Return (0x0C)
                }

                If ((TL13 == Arg0))
                {
                    Return (0x0D)
                }

                If ((TL14 == Arg0))
                {
                    Return (0x0E)
                }

                If ((TL15 == Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (One)
        }

        Method (NATL, 1, NotSerialized)
        {
            If ((NTLE != Zero))
            {
                If ((Arg0 == One))
                {
                    Return (TLE2) /* \_SB_.PCI0.GFX0.TLE2 */
                }

                If ((Arg0 == 0x02))
                {
                    Return (TLE3) /* \_SB_.PCI0.GFX0.TLE3 */
                }

                If ((Arg0 == 0x03))
                {
                    Return (TLE4) /* \_SB_.PCI0.GFX0.TLE4 */
                }

                If ((Arg0 == 0x04))
                {
                    Return (TLE5) /* \_SB_.PCI0.GFX0.TLE5 */
                }

                If ((Arg0 == 0x05))
                {
                    Return (TLE6) /* \_SB_.PCI0.GFX0.TLE6 */
                }

                If ((Arg0 == 0x06))
                {
                    Return (TLE7) /* \_SB_.PCI0.GFX0.TLE7 */
                }

                If ((Arg0 == 0x07))
                {
                    Return (TLE8) /* \_SB_.PCI0.GFX0.TLE8 */
                }

                If ((Arg0 == 0x08))
                {
                    Return (TLE9) /* \_SB_.PCI0.GFX0.TLE9 */
                }

                If ((Arg0 == 0x09))
                {
                    Return (TL10) /* \_SB_.PCI0.GFX0.TL10 */
                }

                If ((Arg0 == 0x0A))
                {
                    Return (TL11) /* \_SB_.PCI0.GFX0.TL11 */
                }

                If ((Arg0 == 0x0B))
                {
                    Return (TL12) /* \_SB_.PCI0.GFX0.TL12 */
                }

                If ((Arg0 == 0x0C))
                {
                    Return (TL13) /* \_SB_.PCI0.GFX0.TL13 */
                }

                If ((Arg0 == 0x0D))
                {
                    Return (TL14) /* \_SB_.PCI0.GFX0.TL14 */
                }

                If ((Arg0 == 0x0E))
                {
                    Return (TL15) /* \_SB_.PCI0.GFX0.TL15 */
                }

                If ((Arg0 == 0x0F))
                {
                    Return (TLE1) /* \_SB_.PCI0.GFX0.TLE1 */
                }
            }

            Return (Zero)
        }
    }

    Method (IDAB, 0, Serialized)
    {
        If (CondRefOf (\_SB.PCI0.GFX0.IDAB))
        {
            \_SB.PCI0.GFX0.IDAB ()
        }
    }

    Method (HGAS, 0, NotSerialized)
    {
        \_SB.PCI0.GFX0.PXGS = One
        Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
    }

    Method (HBRT, 1, Serialized)
    {
        If ((0x04 & DSEN))
        {
            If ((Arg0 == 0x04))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x87) // Device-Specific
            }

            If ((Arg0 == 0x03))
            {
                Notify (\_SB.PCI0.PEG0.PEGP.DD02, 0x86) // Device-Specific
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If ((\_SB.PCI0.GFX0.GSTP != One))
        {
            If ((\_SB.PCI0.GFX0.AGXA == Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                \_SB.PCI0.GFX0.EMDR = One
                If ((\_SB.PCI0.GFX0.EXPM == 0x02))
                {
                    \_SB.PCI0.GFX0.EXPM = Zero
                }
                Else
                {
                    \_SB.PCI0.GFX0.EXPM++
                }

                Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
            }
        }
    }

    Method (HNOT, 1, Serialized)
    {
        Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
        While (One)
        {
            _T_0 = ToInteger (Arg0)
            If ((_T_0 == One))
            {
                If ((\_SB.PCI0.GFX0.GSTP != One))
                {
                    If ((SGMD == 0x02))
                    {
                        If ((\_SB.PCI0.GFX0.AGXA == Zero))
                        {
                            Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
                        }

                        If ((\_SB.PCI0.GFX0.AGXA == One))
                        {
                            Notify (\_SB.PCI0.PEG0.PEGP, 0x80) // Status Change
                        }
                    }
                    Else
                    {
                        \_SB.PCI0.GFX0.DSWR = One
                        Notify (\_SB.PCI0.GFX0, 0x81) // Information Change
                    }
                }
            }
            ElseIf ((_T_0 == 0x02))
            {
                If ((SGMD == 0x02))
                {
                    If ((\_SB.PCI0.GFX0.AGXA == Zero))
                    {
                        Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
                    }

                    If ((\_SB.PCI0.GFX0.AGXA == One))
                    {
                        Notify (\_SB.PCI0.PEG0.PEGP, 0x80) // Status Change
                    }
                }
                Else
                {
                    Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
                }
            }
            ElseIf ((_T_0 == 0x04))
            {
                If ((SGMD == 0x02))
                {
                    If ((\_SB.PCI0.GFX0.AGXA == Zero))
                    {
                        Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
                    }

                    If ((\_SB.PCI0.GFX0.AGXA == One))
                    {
                        Notify (\_SB.PCI0.PEG0.PEGP, 0x80) // Status Change
                    }
                }
                Else
                {
                    Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
                }
            }
            Else
            {
                Notify (\_SB.PCI0.GFX0, 0x80) // Status Change
            }

            Break
        }
    }
}

